//  vue-computed-style -  vue-reactive computed style node
//
//  use:
//		include 'vue-computed-style'
//
//  syntax:
//      <computed-style inline="..." />
//              or
//      <computed-style >...</computed-style>
//
//  generates a vue-reactive, dom STYLE node:
//      <STYLE vue-computed > ... </STYLE>
//
//	implements:
//		vue-reactive CSS text with {{mustache}} substitutions

function Install( ) {
	//  we use low-level uppercase STYLE to trick Vue into cooperating
	Vue.config.ignoredElements.push( 'STYLE' );
	Vue.component( 'COMPUTED-STYLE', ComputedStyle );
	Vue.component( 'computed-style', ComputedStyle );
}
	

const ComputedStyle = {

	//  as mixin
	install:	Install,

	name:		"computed-style",

    props:      ['inline','for','data','methods','computed'],

    template:   `<component :is= whichWay() />`,

    methods:    {

        whichWay() {
                //  retain context
                const vm = this,
					//  prop for= TAG, or defrault parent's tag
                    whom = this.$props.for || this.$parent.$options._componentTag,
					methods = this.$props.methods || { },
					computed = this.$props.computed || { };

				//  prop data= OBJ, or default parent's data
				function data() { return vm.$props.data || vm.$parent.$data };
				

                //  map (per syntax) to define rendering
                const comps = {

                    inline: { name: 'interpolation',
							  data,
                              template: `<STYLE 
                                            vue-computed for="${whom}" inline
											>${ vm.$props.inline }</STYLE>`,
							  methods:  methods,
							  //computed:  computed,
							},
                    slot:   { name: 'interpolation',
					          data,
                              render: function(h){ return h(
                                        "STYLE",
                                            {attrs:{"vue-computed":"",for: whom }},
                                            vm.$slots.default) },
							  methods:  methods,
							  //computed:  computed,
							}
                };

                //  reach thru map to return render descriptor
                var which = this.$props.inline;
                return which ? comps.inline : comps.slot
            },
    },
}

import Vue from 'vue'
Vue.config.ignoredElements.push( 'STYLE' );
Vue.component( 'computed-style', ComputedStyle);
export default ComputedStyle
